#! /usr/bin/env python

import sys

def checkCorrectAnswer(answer):
    if answer == "BAD INPUT":
        sys.stderr.write("Sorry, we cannot help you here.\n")
        sys.exit(1)

def poseQuestion(questionPrompt, acceptableResponses):
    # depending if you teach in Python 3 or 2, 
    # this will work for both versions.
    try:
        input = raw_input
    except NameError:
        pass
    tries = 0
    while tries < 3:
        answer = input(questionPrompt)
        if answer.lower() in acceptableResponses:
            return answer
        tries = tries + 1
        if tries < 3:
           sys.stderr.write("Can you please try again:\n")
 
    return "BAD INPUT"

def main():
    # function that is driving the logic for the program

    coffeeType = poseQuestion("What coffee type would you like? ", ["long black", "flat white", "latte", "short black"])

    checkCorrectAnswer(coffeeType)

    milk = 'N'
    if coffeeType.lower() in ["long black", "short black"]:
        milk = poseQuestion("Would you like milk on the side? [y, n] ", ["y", "n"])
        checkCorrectAnswer(milk)

    takeaway = poseQuestion("Is your coffee takeaway? [y, n] ", ["y", "n"])

    checkCorrectAnswer(takeaway)

    sys.stdout.write("%s\n" % coffeeType)

    if milk.lower() == "y":
        sys.stdout.write("Milk on the side\n")
    else:
        sys.stdout.write("No extras\n")

    if takeaway.lower() == "y":
        sys.stdout.write("Takeaway\n")
    else:
        sys.stdout.write("In cafe\n")

# guiding the entry to the script to function main()
if __name__ == "__main__":
    main()

sys.exit(0)
